﻿/// <reference path="../Scripts/msls.js" />

window.myapp = msls.application;

(function (lightSwitchApplication) {

    var $Entity = msls.Entity,
        $DataService = msls.DataService,
        $DataWorkspace = msls.DataWorkspace,
        $defineEntity = msls._defineEntity,
        $defineDataService = msls._defineDataService,
        $defineDataWorkspace = msls._defineDataWorkspace,
        $DataServiceQuery = msls.DataServiceQuery,
        $toODataString = msls._toODataString;

    function ScheduleEvent(entitySet) {
        /// <summary>
        /// Represents the ScheduleEvent entity type.
        /// </summary>
        /// <param name="entitySet" type="msls.EntitySet" optional="true">
        /// The entity set that should contain this scheduleEvent.
        /// </param>
        /// <field name="Id" type="Number">
        /// Gets or sets the id for this scheduleEvent.
        /// </field>
        /// <field name="Subject" type="String">
        /// Gets or sets the subject for this scheduleEvent.
        /// </field>
        /// <field name="StartTime" type="Date">
        /// Gets or sets the startTime for this scheduleEvent.
        /// </field>
        /// <field name="EndTime" type="Date">
        /// Gets or sets the endTime for this scheduleEvent.
        /// </field>
        /// <field name="AllDay" type="Boolean">
        /// Gets or sets the allDay for this scheduleEvent.
        /// </field>
        /// <field name="Recurrence" type="Boolean">
        /// Gets or sets the recurrence for this scheduleEvent.
        /// </field>
        /// <field name="RecurrenceRule" type="String">
        /// Gets or sets the recurrenceRule for this scheduleEvent.
        /// </field>
        /// <field name="StartTimeZone" type="String">
        /// Gets or sets the startTimeZone for this scheduleEvent.
        /// </field>
        /// <field name="EndTimeZone" type="String">
        /// Gets or sets the endTimeZone for this scheduleEvent.
        /// </field>
        /// <field name="Categorize" type="String">
        /// Gets or sets the categorize for this scheduleEvent.
        /// </field>
        /// <field name="details" type="msls.application.ScheduleEvent.Details">
        /// Gets the details for this scheduleEvent.
        /// </field>
        $Entity.call(this, entitySet);
    }

    function scheduleLSData(dataWorkspace) {
        /// <summary>
        /// Represents the scheduleLSData data service.
        /// </summary>
        /// <param name="dataWorkspace" type="msls.DataWorkspace">
        /// The data workspace that created this data service.
        /// </param>
        /// <field name="ScheduleEvents" type="msls.EntitySet">
        /// Gets the ScheduleEvents entity set.
        /// </field>
        /// <field name="details" type="msls.application.scheduleLSData.Details">
        /// Gets the details for this data service.
        /// </field>
        $DataService.call(this, dataWorkspace);
    };
    function DataWorkspace() {
        /// <summary>
        /// Represents the data workspace.
        /// </summary>
        /// <field name="scheduleLSData" type="msls.application.scheduleLSData">
        /// Gets the scheduleLSData data service.
        /// </field>
        /// <field name="details" type="msls.application.DataWorkspace.Details">
        /// Gets the details for this data workspace.
        /// </field>
        $DataWorkspace.call(this);
    };

    msls._addToNamespace("msls.application", {

        ScheduleEvent: $defineEntity(ScheduleEvent, [
            { name: "Id", type: Number, isReadOnly: true },
            { name: "Subject", type: String },
            { name: "StartTime", type: Date },
            { name: "EndTime", type: Date },
            { name: "AllDay", type: Boolean },
            { name: "Recurrence", type: Boolean },
            { name: "RecurrenceRule", type: String },
            { name: "StartTimeZone", type: String },
            { name: "EndTimeZone", type: String },
            { name: "Categorize", type: String }
        ]),

        scheduleLSData: $defineDataService(scheduleLSData, lightSwitchApplication.rootUri + "/scheduleLSData.svc", [
            { name: "ScheduleEvents", elementType: ScheduleEvent }
        ], [
            {
                name: "ScheduleEvents_SingleOrDefault", value: function (Id) {
                    return new $DataServiceQuery({ _entitySet: this.ScheduleEvents },
                        lightSwitchApplication.rootUri + "/scheduleLSData.svc" + "/ScheduleEvents(" + "Id=" + $toODataString(Id, "Int32?") + ")"
                    );
                }
            }
        ]),

        DataWorkspace: $defineDataWorkspace(DataWorkspace, [
            { name: "scheduleLSData", type: scheduleLSData }
        ])

    });

}(msls.application));
