﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;

namespace LightSwitchApplication.WebApi
{
    public class ScheduleController : ApiController
    {
        // GET api/<controller>
        public IEnumerable<string> Get()
        {
            return new string[] { "value1", "value2" };
        }

        // GET api/<controller>/5
        public string Get(int id)
        {
            return "value";
        }

        // POST api/<controller>
        public void Post([FromBody]string value)
        {
        }

        // PUT api/<controller>/5
        public void Put(int id, [FromBody]string value)
        {
        }

        // DELETE api/<controller>/5
        public void Delete(int id)
        {
        }
        [System.Web.Http.ActionName("GetData")]
        [AcceptVerbs("POST")]
        //To Get the appointments from database 
        public List<FormModel> GetData()
        {
            using (ServerApplicationContext context = ServerApplicationContext.CreateContext())
            {
                var data = context.DataWorkspace.scheduleLSData.ScheduleEvents.Cast<ScheduleEvent>().Select(app => new { app.Id, app.StartLocation, app.StartTime, app.EndTime, app.AllDay, app.Recurrence, app.RecurrenceRule,app.StartTimeZone,app.EndTimeZone,app.Categorize }).ToList();
                return data.Select(app => new FormModel()
                {
                    Id = app.Id,
                    StartLocation = app.StartLocation,
                    StartTime = Convert.ToDateTime(app.StartTime),
                    EndTime = Convert.ToDateTime(app.EndTime),
                    AllDay = app.AllDay,
                    Recurrence = app.Recurrence,
                    RecurrenceRule = app.RecurrenceRule,
                    StartTimeZone=app.StartTimeZone,
                    EndTimeZone=app.EndTimeZone,
                    Categorize=app.Categorize,
                    
                }).ToList();
            }
        }

        //Define FormModel class to Generate List 
        public class FormModel
        {
            public int Id { get; set; }
            public string StartLocation { get; set; }
            public DateTime StartTime { get; set; }
            public DateTime EndTime { get; set; }
            public bool? AllDay { get; set; }
            public bool? Recurrence { get; set; }
            public string RecurrenceRule { get; set; }
            public string StartTimeZone { get; set; }
            public string EndTimeZone { get; set; }
            public string Categorize { get; set; }
        }
        [System.Web.Http.ActionName("Crud")]
        [AcceptVerbs("POST")]
// Method to perform the crud Operation
        public List<FormModel> Crud(EditParams param)
        {
            using (ServerApplicationContext context = ServerApplicationContext.CreateContext())
            {
                if (param.action == "insert" || (param.action == "batch" && param.added.Count>0)) 
// this block of code will execute while inserting the appointments
                {
                    var value = param.action == "insert" ? param.value : param.added.ToList()[0];
                    DateTime startTime = Convert.ToDateTime(value.StartTime);
                    DateTime endTime = Convert.ToDateTime(value.EndTime);
                    ScheduleEvent app = context.DataWorkspace.scheduleLSData.ScheduleEvents.AddNew();
                    {
                        //app.Id = value.Id;
                        app.StartTime = startTime;
                        app.EndTime = endTime;
                        app.StartLocation = value.StartLocation;
                        app.Recurrence = value.Recurrence;
                        app.AllDay = value.AllDay;
                        app.RecurrenceRule = value.RecurrenceRule;
                        app.StartTimeZone = value.StartTimeZone;
                        app.EndTimeZone = value.EndTimeZone;
                        app.Categorize = value.Categorize;
                    };
                    context.DataWorkspace.scheduleLSData.SaveChanges();
                }
                if ((param.action == "batch" && param.deleted.Count>0) || param.action == "remove")  
// this block of code will execute while removing the appointment
                {
                    if (param.action == "remove")
                    {
                            context.DataWorkspace.scheduleLSData.ScheduleEvents.Cast<ScheduleEvent>().ToList().Where(c => c.Id == Convert.ToInt32(param.key)).FirstOrDefault().Delete();
                    }
                    else
                    {
                        foreach (var app in param.deleted)
                            context.DataWorkspace.scheduleLSData.ScheduleEvents.Cast<ScheduleEvent>().ToList().Where(c => c.Id == Convert.ToInt32(app.Id)).FirstOrDefault().Delete();
                    }
                    context.DataWorkspace.scheduleLSData.SaveChanges();
                }
                if ((param.action == "batch" && param.changed.Count>0) || param.action == "update")   
// this block of code will execute while updating the appointment
                {
                    var value = param.action == "update" ? param.value : param.changed.ToList()[0];
                    var filterData = context.DataWorkspace.scheduleLSData.ScheduleEvents.Cast<ScheduleEvent>().Where(c => c.Id == Convert.ToInt32(value.Id));
                    if (filterData.Count() > 0)
                    {
                        DateTime startTime = Convert.ToDateTime(value.StartTime);
                        DateTime endTime = Convert.ToDateTime(value.EndTime);
                        ScheduleEvent appoint = context.DataWorkspace.scheduleLSData.ScheduleEvents.Cast<ScheduleEvent>().Single(A => A.Id == Convert.ToInt32(value.Id));
                        appoint.StartTime = startTime;
                        appoint.EndTime = endTime;
                        appoint.StartLocation = value.StartLocation;
                        appoint.Recurrence = value.Recurrence;
                        appoint.AllDay = value.AllDay;
                        appoint.RecurrenceRule = value.RecurrenceRule;
                        appoint.StartTimeZone = value.StartTimeZone;
                        appoint.EndTimeZone = value.EndTimeZone;
                        appoint.Categorize = value.Categorize;
                    }
                    context.DataWorkspace.scheduleLSData.SaveChanges();
                }
            }
            ServerApplicationContext context1 = ServerApplicationContext.CreateContext();
            var data = context1.DataWorkspace.scheduleLSData.ScheduleEvents.Cast<ScheduleEvent>().Select(app => new { app.Id, app.StartLocation, app.StartTime, app.EndTime, app.AllDay, app.Recurrence, app.RecurrenceRule, app.StartTimeZone, app.EndTimeZone,app.Categorize }).ToList();
            return data.Select(app => new FormModel()
            {
                Id = app.Id,
                StartLocation = app.StartLocation,
                StartTime = Convert.ToDateTime(app.StartTime),
                EndTime = Convert.ToDateTime(app.EndTime),
                AllDay = app.AllDay,
                Recurrence = app.Recurrence,
                RecurrenceRule = app.RecurrenceRule,
                StartTimeZone = app.StartTimeZone,
                EndTimeZone = app.EndTimeZone,
                Categorize=app.Categorize,
            }).ToList();
            //return param;
        }

        public class EditParams
        {
            public string key { get; set; }
            public string action { get; set; }
            public virtual ICollection<FormModel> added { get; set; }
            public virtual ICollection<FormModel> changed { get; set; }
            public virtual ICollection<FormModel> deleted { get; set; }
            public FormModel value { get; set; }
        }
    }
}